import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    vue(),
  ],
  resolve: {
    alias: {
      '@': fileURLToPath(new URL('./src', import.meta.url))
    }
  },

  server: {
    host: '0.0.0.0', // 指定IP地址，0.0.0.0表示可从任何IP访问
    port: 5173, // 指定端口号
    proxy: {
      // 在此处编写代理规则
      '/api': {
        secure: false,
        //target: 'https://test.yqt.com',
        target: 'https://c.apxly.com',
        changeOrigin: true,
        rewrite: (path) => {
          return path.replace(/\/api/, '')
        }
      }
    }
  }
})
